﻿using System;
using System.Collections.Generic;
using NUnit.Framework;
using Omu.ValueInjecter;

namespace Tests
{
    public class Cloning
    {
        public class Foo
        {
            public string Name { get; set; }
            public int Number { get; set; }
            public Foo F1 { get; set; }
            public IEnumerable<Foo> Foos { get; set; }
        }

        [Test]
        [Ignore("not finished yet")]
        public void Test()
        {
            var o = new Foo
            {
                Name = "a",
                Number = 12,
                F1 = new Foo { Name = "b" },
                Foos = new List<Foo>
                                           {
                                               new Foo { Name = "j1" },
                                               new Foo { Name = "j2" },
                                           }
            };

            var c = new Foo().InjectFrom<CloneInjection>(o) as Foo;

            Assert.AreEqual(o.F1.Name, c.F1.Name);
            Assert.AreNotEqual(o.F1, c.F1);
        }

        public class CloneInjection : ConventionInjection
        {
            protected override bool Match(ConventionInfo c)
            {
                return c.SourceProp.Value != null;
            }

            protected override object SetValue(ConventionInfo c)
            {
                if (c.SourceProp.Type.IsValueType || c.SourceProp.Type == typeof(string))
                    return c.SourceProp.Value;

                return Activator.CreateInstance(c.SourceProp.Type).InjectFrom<CloneInjection>(c.SourceProp.Value);
            }

        }
    }
}