﻿namespace Omu.ValueInjecter
{
    public abstract class PrefixedValueInjection : LoopValueInjectionBase
    {
        protected string targetPrefix;

        protected string sourcePrefix;

        public PrefixedValueInjection TargetPrefix(string prefix)
        {
            targetPrefix = prefix;
            return this;
        }

        public PrefixedValueInjection SourcePrefix(string prefix)
        {
            sourcePrefix = prefix;
            return this;
        }

        /// <summary>
        /// get a string representing the target property name using the source property name and prefixes
        /// </summary>
        /// <param name="s">source property original name</param>
        /// <returns></returns>
        protected string SearchTargetName(string s)
        {
            return targetPrefix + s.RemovePrefix(sourcePrefix);
        }

        /// <summary>
        /// get a string representing the source property name using the target property name and prefixes
        /// </summary>
        /// <param name="s">target property original name</param>
        /// <returns></returns>
        protected string SearchSourceName(string s)
        {
            return sourcePrefix + s.RemovePrefix(targetPrefix);
        }
    }
}